#ifndef PC60_H_INCLUDED
#define PC60_H_INCLUDED

#include <SDL.h>

#include "typedef.h"

#include "config.h"
#include "joystick.h"
#include "movie.h"
#include "replay.h"
#include "thread.h"
#include "vsurface.h"


#define	FRAMERATE	(VSYNC_HZ/(cfg->GetFrameSkip()+1))


class CPU6;
class SUB6;
class IO6;
class MEM6;
class VDG6;
class DSP6;
class INT6;
class KEY6;
class DSK6;
class CMTL;
class CMTS;
class SND6;
class PSG6;
class PIO6;
class SCH6;
class VCE6;
class cWndStat;

#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
class BPoint;
class cWndReg;
class cWndMem;
class cWndMon;
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// {z}VNX
class VM6 : public cThread, public AVI6, public REPLAY {
	
	// vm->xxx gɂfriendłȂȂBƃCB
	friend class VDG6;
	friend class VDG60;
	friend class VDG62;
	friend class DSP6;
	friend class SUB6;
	friend class PIO6;
	friend class CPU6;
	friend class PSG6;
	friend class INT6;
	friend class VCE6;
	friend class CMTL;
	friend class DSK6;
	friend class DSK60;
	friend class DSK66;
	friend class SCH6;
	friend class KEY6;
	friend class cWndStat;
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	friend class BPoint;
	friend class cWndReg;
	friend class cWndMem;
	friend class cWndMon;
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
public:
	enum ReturnCode
	{
		Quit = 0,
		Restart,
		Doko,
		Replay,
		Error,
		
		EndofReturnCode
	};
	
protected:
	// IuWFNg|C^
	cConfig *cfg;				// ݒIuWFNg
	IO6 *io;					// I/O(Z80)
	IO6 *ios;					// I/O(SUB CPU)
	INT6 *intr;					// 
	SCH6 *sche;					// XPW[
	SND6 *snd;					// TEh
	CPU6 *cpum;					// CPU
	SUB6 *cpus;					// SUB CPU
	MEM6 *mem;					// 
	VDG6 *vdg;					// VDG
	DSP6 *graph;				// ʕ`
	PSG6 *psg;					// PSG
	VCE6 *voice;				// 
	PIO6 *pio;					// 8255
	KEY6 *key;					// L[
	CMTL *cmt;					// CMT
	CMTS *cmts;					// CMT(SAVE)
	DSK6 *disk;					// DISK
	cJoy *joy;					// WCXeBbN
	
	cWndStat *staw;				// Xe[^Xo[
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	BPoint *bp;					// u[N|Cg
	cWndReg *regw;				// WX^EBhE
	cWndMem *memw;				// EBhE
	cWndMon *monw;				// j^EBhE
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	SDL_TimerID UpDateFPSID;	// FPS\^C}ID
	
	COLOR24 GPal[256];			// pbg
	
	BOOL ScreenUpdate();								// ʍXV
	int SoundUpdate( int, cRing * = NULL );				// TEhXV
	static void StreamUpdate( void *, BYTE *, int);		// Xg[XV R[obN֐
	static Uint32 UpDateFPS( Uint32, void * );			// FPS\^C} R[obN֐
	BOOL SetFPSTimer( int );							// FPS\^C}ݒ
	
	int UDFPSCount;				// FPS\^C}JE^
	int FSkipCount;				// t[XLbvJE^
	
	void OnThread( void * );				// Xbh֐
	BOOL IsWaitEnable();					// WaitL?
	
	BOOL CheckFuncKey( SDL_Event * );		// e@\L[`FbN
	
	
	// L[͏\
	typedef struct{
		char *Buffer;			// L[obt@|C^
		int Num;				// c蕶
		int Wait;				// ҂񐔃JE^
		BOOL Relay;				// [XCb`OFF҂tO
		int Seek;
	} AKEY;
	AKEY ak;					// L[͏
	
	char GetAutoKey();			// L[1擾
	
	
	
public:
	VM6();									// RXgN^
	virtual ~VM6();							// fXgN^
	
	virtual BOOL Init( const cConfig * ) = 0;	// 
	BOOL InitCommon();						// ʕ
	
	BOOL Start();							// Jn
	void Stop();							// ~
	void Reset();							// Zbg
	
	int Emu();								// 1ߎs
	int EmuVSYNC();							// 1ʕs
	
	#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	void Exec( int );						// wXe[gs
	BOOL ToggleMonitor();					// j^[hؑւ
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	ReturnCode EventLoop();					// Cxg[v
	
	void ShowPopupMenu( int, int );			// |bvAbvj[\
	
	
	BOOL IsAutoKey();						// L[͎s?
	BOOL SetAutoKey( char *, int );			// L[͕ݒ
	BOOL SetAutoKeyFile( char * );			// L[͕ݒ(t@C)
	
	
	// ------------------------------------------
	BOOL DokoDemoSave( char * );	// ǂłSAVE
	BOOL DokoDemoLoad( char * );	// ǂłLOAD
	// ------------------------------------------
};

// PC-6001 z}VNX
class VM60 : public VM6 {
public:
	VM60();			// RXgN^
	~VM60();		// fXgN^
	
	BOOL Init( const cConfig * );	// 
};

// PC-6001mk2 z}VNX
class VM62 : public VM6 {
public:
	VM62();			// RXgN^
	~VM62();		// fXgN^
	
	BOOL Init( const cConfig * );	// 
};

// PC-6601 z}VNX
class VM66 : public VM6 {
public:
	VM66();			// RXgN^
	~VM66();		// fXgN^
	
	BOOL Init( const cConfig * );	// 
};

#endif		// PC60_H_INCLUDED
