#include <stdlib.h>
#include <errno.h>

#include "typedef.h"
#include "config.h"
#include "console.h"
#include "error.h"
#include "osd.h"
#include "pc60.h"

#include "icons.h"


///////////////////////////////////////////////////////////
// C
///////////////////////////////////////////////////////////
int main( int argc, char *argv[] )
{
	VM6 *P6Core             = NULL;			// IuWFNg|C^
	VM6::ReturnCode Restart = VM6::Quit;	// ċNtO
	cConfig *Cfg            = NULL;			// ݒIuWFNg
	
	
	// ϐݒ(eXgp)
//	putenv( "SDL_VIDEODRIVER=windib" );
//	putenv( "SDL_VIDEODRIVER=directx" );
//	putenv( "SDL_AUDIODRIVER=dsound" );
	
	
	// dN֎~
	if( OSD_IsWorking() ) return FALSE;
	
	
	// SDL
	if( SDL_Init( SDL_INIT_TIMER | SDL_INIT_AUDIO | SDL_INIT_VIDEO | SDL_INIT_JOYSTICK ) < 0 ){
		Error::SetError( Error::LibInitFailed );
		OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		OSD_Finish();	// I
		return FALSE;
	}
	
	
	// INIt@CǍ
	Cfg = new cConfig();
	if( !Cfg ){
		SDL_Quit();		// SDLVbg_E
		OSD_Finish();	// I
	}
	if( !Cfg->Init() ){
		switch( Error::GetError() ){
		case Error::IniDefault:
			OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONWARNING );
			Error::SetError( Error::NoError );
			break;
			
		default:
			OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
			SDL_Quit();				// SDLVbg_E
			OSD_Finish();			// I
			if( Cfg ) delete Cfg;	// ݒIuWFNgJ
			return FALSE;
		}
	}
	
	// tHgt@C΍쐬
	if( !OSD_FileExist( Cfg->GetFontFileH() ) ) OSD_CreateFont( Cfg->GetFontFileH(), NULL, FSIZE );
	if( !OSD_FileExist( Cfg->GetFontFileZ() ) ) OSD_CreateFont( NULL, Cfg->GetFontFileZ(), FSIZE );
	
	
	// P6IuWFNg쐬Ďs
	do{
		// ROMt@C݃`FbN&@ύX
		char RomSerch[PATH_MAX];
		int IniModel = Cfg->GetModel();
		sprintf( RomSerch, "%s*.%2d", Cfg->GetRomPath(), IniModel );
		if( !OSD_FileExist( RomSerch ) ){
			int models[] = { 60, 62, 66 };
			for( int i=0; i < COUNTOF(models); i++ ){
				sprintf( RomSerch, "%s*.%2d", Cfg->GetRomPath(), models[i] );
				if( OSD_FileExist( RomSerch ) ){
					Cfg->SetModel( models[i] );
					break;
				}
			}
			// ROM?
			if( IniModel != Cfg->GetModel() ){
				Error::SetError( Error::RomChange );
				OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONWARNING );
				Error::SetError( Error::NoError );
			}
		}
		
		// @P6IuWFNgm
		BYTE *ipix, *imsk;
		switch( Cfg->GetModel() ){
		case 62: P6Core = new VM62; ipix = (BYTE *)p62pix; imsk = (BYTE *)p62msk; break;
		case 66: P6Core = new VM66; ipix = (BYTE *)p66pix; imsk = (BYTE *)p66msk; break;
		default: P6Core = new VM60; ipix = (BYTE *)p60pix; imsk = (BYTE *)p60msk;
		}
		
		// ACRݒ
		SDL_Surface *p6icon = SDL_CreateRGBSurfaceFrom( ipix, 32, 32, 24, 32*3, 0, 0, 0, 0 );
		SDL_WM_SetIcon( p6icon, imsk );
		SDL_FreeSurface( p6icon );
		
		// VMĎs
		if( P6Core->Init( Cfg ) ){
			switch( Restart ){
			case VM6::Doko:		// ǂłLOAD?
				P6Core->DokoDemoLoad( Cfg->GetDokoFile() );
				break;
				
			case VM6::Replay:	// vCĐ?
			{
				char temp[PATH_MAX];
				strncpy( temp, Cfg->GetDokoFile(), PATH_MAX );
				P6Core->DokoDemoLoad( temp );
				P6Core->REPLAY::StartReplay( temp );
			}
				break;
				
			default:
				break;
			}
			
			P6Core->Start();
			Restart = P6Core->EventLoop();
			P6Core->Stop();
		}else{
			// sꍇ
			OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONERROR );
		}
		
		// P6IuWFNgJ
		if( P6Core ) delete P6Core;
		
		
		// ċNȂINIt@CēǍ
		if( Restart == VM6::Restart ){
			if( !Cfg->Init() ){
				Error::SetError( Error::IniDefault );
				OSD_Message( (char *)Error::GetErrorText(), MSERR_ERROR, OSDR_OK | OSDM_ICONWARNING );
				Error::SetError( Error::NoError );
			}
		}
		
	}while( Restart != VM6::Quit );
	
	
	
	// ݒIuWFNgJ
	if( Cfg ) delete Cfg;
	
	// SDLVbg_E
	SDL_Quit();
	
	// I
	OSD_Finish();
	
	return TRUE;
}
