#ifndef SCHEDULE_H_INCLUDED
#define SCHEDULE_H_INCLUDED

#include "typedef.h"

#include "device.h"
#include "ini.h"
#include "p6device.h"
#include "thread.h"


// őCxg
#define	MAXEVENT	(32)

// CxgX^CtO
// bit0: JԂw
#define	EV_ONETIME	(0x00)	/* ^C */
#define	EV_LOOP		(0x01)	/* [v */
// bit1,2: wP
#define	EV_HZ		(0x00)	/* Hz */
#define	EV_US		(0x02)	/* us */
#define	EV_MS		(0x04)	/* ms */
#define	EV_STATE	(0x08)	/* CPUXe[g */


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cSche {
public:
	// Cxg\
	typedef struct {
		P6DEVICE* device;	// CxgfoCXIuWFNg|C^
		int id;				// CxgID
		BOOL Active;		// CxgLtO TRUE:L FALSE:~
		int Period;			// 1̃NbN
		int Clock;			// cNbN
		double nps;			// Cxgg(Hz)
	} evinfo;
	
protected:
	evinfo ev[MAXEVENT];	// Cxg
	
	int MasterClock;		// }X^NbN({IɂCPUXe[g/bɂȂ͂)
	
	int NextEvent;			// ̃Cxg܂ł̃NbN
	int SaveClock;			// NbN𗭂ߍ
	
	// xvZp
	DWORD WRClock;			// NbNۑ(v)
	DWORD WRClockTmp;		// NbNۑ(v)
	
	evinfo *Find( P6DEVICE *, int );			// Cxg
	void SetMasterClock( int );					// }X^NbNݒ
	
public:
	cSche( int );								// RXgN^
	virtual ~cSche();							// fXgN^
	
	BOOL Add( P6DEVICE *, int, double, int );	// Cxgǉ
	BOOL Del( P6DEVICE *, int );				// Cxg폜
	
	BOOL SetHz( P6DEVICE *, int, double );		// Cxggݒ
	
	void Update( int );							// CxgXV
	void Reset( P6DEVICE *, int, double=0 );	// wCxgZbg
	
	int Rest( P6DEVICE *, int );				// Cxg܂ł̎cNbN߂
	double Scale( P6DEVICE *, int );			// Cxg̐is߂
	
	BOOL GetEvinfo( evinfo * );					// Cxg擾
	BOOL SetEvinfo( evinfo * );					// Cxgݒ
	
	int GetMasterClock();						// }X^[NbN擾
};

class SCH6 : public P6DEVICE, public cSche, public cThread, public cSemaphore, public IDoko {
protected:
	BOOL WaitEnable;		// WaitLtO
	BOOL VSYNC;				// VSYNCtO TRUE:VSYNCɒB FALSE:BĂȂ
	int EnableScrUpdate;	// ʍXVtO
	
	void OnThread( void * );					// Xbh֐
	
public:
	SCH6( VM6 *, const P6ID&, int );			// RXgN^
	virtual ~SCH6();							// fXgN^
	
	BOOL Init();								// 
//	void CalcCpuState();						// ʂ̕\ԂɉCPUXe[gvZ
	
	BOOL Start();								// Jn
	void Stop();								// ~
	
	BOOL GetWaitEnable();						// WaitLtO擾
	void SetWaitEnable( BOOL );					// WaitLtOݒ
	
	BOOL IsVSYNC();								// VSYNCɒB?
	void OnVSYNC();								// VSYNCʒm
	void VWait();								// VSYNC Wait
	void WaitReset();							// Wait
	
	int GetRatio();								// sx擾
	
	BOOL IsScreenUpdate();						// ʍXV}?
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ǂłSAVE
	BOOL DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};

#endif	// SCHEDULE_H_INCLUDED
